/*************************************************************************************************************************
									File Details
**************************************************************************************************************************
	File name 							: CGUInit.h
	Purpose								: Includes the macros, variables and function declarations for CGUInit.C
	Author								: Nabeel
	VDSP version used for testing		: ..
										  Version: 
                                          Build id: 
	Hardware used						: N/A
	Connection details 					: N/A
	Guidelines for change				: N/A
**************************************************************************************************************************/
#ifndef CGUINIT_H_
#define CGUINIT_H_

//#include "ProcInclude.h"
#ifdef __ADSPBF7xx__
	#include "defBF707.h"
	#include "cdefBF707.h"
	#include <ccblkfn.h>
	#include <sysreg.h>
#endif


#ifdef __ADSPSC5xx__
	#include "defSC589.h"
	#include "cdefSC589.h"
#ifdef __ADSPSHARC__
	#include <sysreg.h>
#endif
#endif


#include <stdio.h>
#include <stdarg.h>
#include <stdint.h>


// Macros for CLKOUT options for SC589
#define CLKIN0              0
#define CLKIN1              1
#define CGU2_0_SYSCLK       2
#define CLKO0               3
#define	CLKO2               4
#define	CLKO3               5
#define	CLKO5               6
#define	CLKO7               7
#define	CLKO8               8
#define	USB_XCLK            9
#define	USBCLKBUF           10
#define	WOCLK0              11
#define	WOCLK1              12
#define	PMONCLK             13
#define	CLK1HZ              14
#define	MLBPLLCLK           15
#define	PCIPHYCLK           16
#define	TMU_CLK             17
#define	FROCLK              18

// Macros for CLKOUT options for BF70x
#define CLKIN               0
#define CCLK_BY_16          1
#define SYSCLK_BY_8         2
#define SCLK0_BY_8          3
#define SCLK1_BY_8          4
#define DCLK_BY_8           5
#define USBCLK              6
#define OUTCLK              7
#define USB_CLKIN           8
#define WOCLK               9
#define PMON                10
#define GND                 11
#define FRO                 13
#define RTC                 14
#define RCU_SYSRES          15


//PLL Multiplier and Divisor Selections (Required Value, Bit Position)
/*#define MSEL(X)         ((X  << BITP_CGU_CTL_MSEL) 	& BITM_CGU_CTL_MSEL) 	//PLL Multiplier Select [1-127]: PLLCLK = ((CLKIN x MSEL/DF+1))
#define DF(X)	        ((X  << BITP_CGU_CTL_DF)    & BITM_CGU_CTL_DF )		// Divide frequency[true or false]
#define CSEL(X)         ((X  << BITP_CGU_DIV_CSEL)	& BITM_CGU_DIV_CSEL)	//Core Clock Divisor Select [1-31]: (CLKIN x MSEL/DF+1)/CSEL 
#define SYSSEL(X)       ((X  << BITP_CGU_DIV_SYSSEL)& BITM_CGU_DIV_SYSSEL)	//System Clock Divisor Select [1-31]: (CLKIN x MSEL/DF+1)/SYSSEL
#define S0SEL(X)        ((X  << BITP_CGU_DIV_S0SEL)	& BITM_CGU_DIV_S0SEL)	//SCLK0 Divisor Select [1-7]: SYSCLK/S0SEL
#define S1SEL(X)        ((X  << BITP_CGU_DIV_S1SEL)	& BITM_CGU_DIV_S1SEL)	//SCLK1 Divisor Select [1-7]: SYSLCK/S1SEL
#define DSEL(X)         ((X  << BITP_CGU_DIV_DSEL)	& BITM_CGU_DIV_DSEL) 	//DDR Clock Divisor Select [1-31]: (CLKIN x MSEL/DF+1)/DSEL
#define OSEL(X)         ((X  << BITP_CGU_DIV_OSEL)	& BITM_CGU_DIV_OSEL) 	//OUTCLK Divisor Select [1-127]: (CLKIN x MSEL/DF+1)/OSEL
#define CLKOUTSEL(X)    ((X  << BITP_CGU_CLKOUTSEL_CLKOUTSEL)	& BITM_CGU_CLKOUTSEL_CLKOUTSEL) 	//CLKOUT Select [0-8]
*/
#define CLKIN_BF70x     25000000          /* CLKIN to processor in Hz */
#define CLKIN_SC589     25000000          /* CLKIN to processor in Hz */

#define PLLCLK_MAX_70X      800
#define CCLK_MAX_70X        400
#define SYSCLK_MAX_70X      200
#define S0CLK_MAX_70X       100
#define S1CLK_MAX_70X       200
#define DDRCLK_MAX_70X      200
#define OUTCLK_MAX_70X      50

#define PLLCLK_MAX_589      1000
#define CCLK_MAX_589        450
#define SYSCLK_MAX_589      225
#define S0CLK_MAX_589       113
#define S1CLK_MAX_589       113
#define DDRCLK_MAX_589      450
#define OUTCLK_MAX_589      450

/*  PLL Multiplier and Divisor Selections (Required Value, Bit Position) */
#define MSEL(X)   		((X << BITP_CGU_CTL_MSEL) 				& BITM_CGU_CTL_MSEL) 						/* PLL Multiplier Select */
#define DF(X)	  		((X << BITP_CGU_CTL_DF) 				& BITM_CGU_CTL_DF )							/* Divide frequency[true or false] */
#define CSEL(X)   		((X  << BITP_CGU_DIV_CSEL)				& BITM_CGU_DIV_CSEL)						/* Core Clock Divisor Select */
#define SYSSEL(X) 		((X  << BITP_CGU_DIV_SYSSEL)  			& BITM_CGU_DIV_SYSSEL)						/* System Clock Divisor Select */
#define S0SEL(X)  		((X  << BITP_CGU_DIV_S0SEL)				& BITM_CGU_DIV_S0SEL)						/* SCLK0 Divisor Select  */
#define S1SEL(X)  		((X  << BITP_CGU_DIV_S1SEL)				& BITM_CGU_DIV_S1SEL)						/* SCLK1 Divisor Select  */
#define DSEL(X)   		((X  << BITP_CGU_DIV_DSEL)				& BITM_CGU_DIV_DSEL) 						/* DDR Clock Divisor Select */
#define OSEL(X)   		((X  << BITP_CGU_DIV_OSEL)				& BITM_CGU_DIV_OSEL) 						/* OUTCLK Divisor Select */
#define CLKOUTSEL(X)    ((X  << BITP_CGU_CLKOUTSEL_CLKOUTSEL)	& BITM_CGU_CLKOUTSEL_CLKOUTSEL) 			/* CLKOUT select	*/
#define USBCLKSEL(X)    ((X  << BITP_CGU_CLKOUTSEL_USBCLKSEL)	& BITM_CGU_CLKOUTSEL_USBCLKSEL) 			/* USBCLKSEL select */


#define DIV_MASK		(BITM_CGU_DIV_CSEL | BITM_CGU_DIV_S0SEL | BITM_CGU_DIV_SYSSEL |BITM_CGU_DIV_S1SEL | BITM_CGU_DIV_DSEL | BITM_CGU_DIV_OSEL)
																										/*  Mask for dividers in CGU_DIV register  */
#define CTL_MASK		(BITM_CGU_CTL_MSEL | BITM_CGU_CTL_DF)												/* Mask for MSEL and DF in CGU_CTL register	*/


#define BITM_ROM_SYSCTRL_CGU_DIV						0x0001
#define BITM_ROM_SYSCTRL_CGU_AUTO_DIS					0x0002
#define BITM_ROM_SYSCTRL_CGU_CTL						0x0004

//#define BITM_CDU_STAT_CLKO8		0x00000100

typedef struct CGU_Settings																	/* Structure to pass the values to CGU driver */
{
	uint32_t ctl_MSEL:7;
	uint32_t ctl_DF:1;
	uint32_t div_CSEL:5;
	uint32_t div_SYSSEL:5;
	uint32_t div_S0SEL:3;
	uint32_t div_S1SEL:3;
	uint32_t div_DSEL:5;
	uint32_t div_OSEL:7;
	uint32_t reserved0:28; /* 64 bits */
}CGU_Settings;




typedef struct _CDU_MAPPINGS																	/* Structure to pass the values to CDU_Init function */
{
	uint32_t cfg0_SEL:2;
    uint32_t cfg0_EN:1;
    uint32_t cfg1_SEL:2;
    uint32_t cfg1_EN:1;
    uint32_t cfg2_SEL:2;
    uint32_t cfg2_EN:1;
    uint32_t cfg3_SEL:2;
    uint32_t cfg3_EN:1;
    uint32_t cfg4_SEL:2;
    uint32_t cfg4_EN:1;
    uint32_t cfg5_SEL:2;
    uint32_t cfg5_EN:1;
    uint32_t cfg6_SEL:2;
    uint32_t cfg6_EN:1;
    uint32_t cfg7_SEL:2;
    uint32_t cfg7_EN:1;
    uint32_t cfg8_SEL:2;
    uint32_t cfg8_EN:1;
    uint32_t cfg9_SEL:2;
    uint32_t cfg9_EN:1;
	uint32_t reserved0:5; /* 32 bits */
}_CDU_MAPPINGS;


typedef struct _CGU_CLOCKDIVIDERS																	/* Structure to pass the values to CGU_Init function */
{
    uint32_t ctl_MSEL:7;
    uint32_t ctl_DF:1;
    uint32_t div_CSEL:5;
    uint32_t div_SYSSEL:5;
    uint32_t div_S0SEL:3;
	uint32_t div_S1SEL:3;
    uint32_t div_DSEL:5;
	uint32_t div_OSEL:7;
	uint32_t reserved0:28; /* 64 bits */
}_CGU_CLOCKDIVIDERS;

/**************************************************************************************************************************
	Function name	:   CGU_Init
    Description		:   This function initializes the CGU to configure different clocks in system.

	Arguments		:	Parameter			 |	Description		 						| Valid values
						uiCguNo		 	     |  Instance of CGU         				| 0, 1
						uiClkinsel		     |  CLKIN source for CGU    				| 0, 1
						*pClocks		     |  Pointer to Structure which holds        | MSEL, DF, CSEL, SYSSEL, S0SEL, 
                                                different Clock multipliers and           S1SEL, DSEL, OSEL values  
                                                dividers                                                                                         				
                        uiClkoutsel          |  Selects one of the clock to CLKOUT      | Processor dependent
	Return value	:   Success/Error code.
**************************************************************************************************************************/
uint32_t CGU_Init(uint32_t uiCguNo, uint32_t uiClkinsel, CGU_Settings *pClocks,  uint32_t uiClkoutsel);


/**************************************************************************************************************************
	Function name	:   CDU_Init
    Description		:   This function allows the user to map the different clocks from CGU0 and CGU1 to different targets

	Arguments		:	Parameter			 |	Description		 						| Valid values
						*pClock_Map		     |  Pointer to Structure which              | CLKO0 - CLKO9
                                                which holds the CDU mapping values		
                                                and enable bits
                                                
                          -----------------------------------------------------------------------------------     
                          | Structure value     0           1           2           3           Target      |
                          -----------------------------------------------------------------------------------
                                CLKO0	        CCLK0_0	    SYSCLK0_0	NA	        NA	    	DSP0
                                CLKO1	        CCLK0_0	    SYSCLK0_0	NA	        NA	    	DSP1
                                CLKO2	        CCLK1_0	    SYSCLK0_0	NA	        NA	    	ARM
                                CLKO3	        DCLK_0	    DCLK_1	    NA	        NA	    	DDR
                                CLKO4	        OCLK_0	    OCLK_1	    DCLK_1	    NA	    	CAN 
                                CLKO5	        OCLK_0	    OCLK_1	    DCLK_1	    DCLK_0	   	SPDIF
                                CLKO6	        OCLK_0	    CCLK0_1	    NA	        NA	    	PCIe
                                CLKO7	        SCLK1_0	    SCLK1_1	    CCLK0_1	    OCLK_0	   	GigE 
                                CLKO8	        SCLK0_0	    SCLK0_1	    CCLK1_1	    DCLK_1	   	LP 
                                CLKO9	        OCLK_0/2	OCLK_1/2	CCLK1_1	    DCLK_1		SDIO 
                                                                                          
	Return value	:   None.
**************************************************************************************************************************/
void CDU_Init(struct _CDU_MAPPINGS *pClock_Map);

uint32_t CGU0_write(uint32_t dActionFlags, CGU_Settings *pCGU_Settings, uint32_t uiClkOutSel);
uint32_t CGU1_write(uint32_t dActionFlags, CGU_Settings *pCGU_Settings, uint32_t uiClkOutSel);
void Program_Cgu0(uint32_t dActionFlags, uint32_t dPllBypassed, uint32_t dPllEnabled, uint32_t dNewCguDiv, CGU_Settings *pCGU_Settings);
void Program_Cgu1(uint32_t dActionFlags, uint32_t dPllBypassed, uint32_t dPllEnabled, uint32_t dNewCguDiv, CGU_Settings *pCGU_Settings);

void CGU_Freq_Check_Round(CGU_Settings *pClocks, float uiClkinValue);

void Fullon_To_Active(unsigned int uiCGU_ID);
void Active_To_Fullon(unsigned int uiCGU_ID);
void Active_To_ActivePLLDis(unsigned int uiCGU_ID);
void ActivePLLDis_To_Active(unsigned int uiCGU_ID);

#endif /* CGUINIT_H_ */
